include("test_penseq.jl")

println("\n\nOra minimizziamo L(x,mu^*) ripartendo dal punto x0")
println("Premi enter per continuare")
readline()

La(x) = L(x,la,mu)
function gradLa!(storage,x)
	gLa = nabla_L(x,la,mu)
	for i = 1:length(x)
		storage[i] = gLa[i]
	end
end

res = optimize(La,gradLa!,xo,g_tol=1.e-7)
xk = res.minimizer

@printf("\nPrimal \"solution\":\n")
for i = 1:n
	@printf("\t x[%3d] = %13.6e\n",i,xk[i])
end
@printf("  Dual solution:\n")
for i = 1:m
	@printf("\tla[%3d] = %13.6e\n",i,la[i])
end
for i = 1:p
	@printf("\tmu[%3d] = %13.6e\n",i,mu[i])
end

viol = feasibility_measure(xk)
kkt  = violkkt(xk,la,mu)
@printf("\n\n Ammissibilità del punto ottenuto: %13.6e\n",viol)
@printf("    Ottimalità del punto ottenuto: %13.6e\n",kkt)


println("\n\nOra minimizziamo La(x,mu^*) ripartendo dal punto x0")
println("Premi enter per continuare")
readline()

eps = 1.e-3
La(x) = L(x,la,mu) + h(x)'*h(x)/eps
function gradLa!(storage,x)
	gLa = nabla_L(x,la,mu) + 2*nabla_h(x)*h(x)/eps
	for i = 1:length(x)
		storage[i] = gLa[i]
	end
end

res = optimize(La,gradLa!,xo,g_tol=1.e-7)
xk = res.minimizer

@printf("\nPrimal \"solution\":\n")
for i = 1:n
	@printf("\t x[%3d] = %13.6e\n",i,xk[i])
end
@printf("  Dual solution:\n")
for i = 1:m
	@printf("\tla[%3d] = %13.6e\n",i,la[i])
end
for i = 1:p
	@printf("\tmu[%3d] = %13.6e\n",i,mu[i])
end

viol = feasibility_measure(xk)
kkt  = violkkt(xk,la,mu)
@printf("\n\n Ammissibilità del punto ottenuto: %13.6e\n",viol)
@printf("    Ottimalità del punto ottenuto: %13.6e\n",kkt)

