#####################################################
push!(LOAD_PATH, pwd())

using ForwardDiff
using Optim
using problema

probname = "hs23"
probname = "hs09"
probname = "hs15"
probname = "ex2"
probname = "maratos"
probname = "ex3"
probname = "hs18"
probname = "hs10"
probname = "hs12"
probname = "hs22"
probname = "hs13"
probname = "hs16"
probname = "hs14"
probname = "hs11"
probname = "hs19"
probname = "hs21"
probname = "hs07"
probname = "hs06"
probname = "hs08"
probname = "hs17"
probname = "hs20"
probname = "ex5"
probname = "ex7"
probname = "ex4"
probname = "hs24"
probname = "ex1"
probname = "hs25"
probname = "hs26"
probname = "hs27"
probname = "hs28"
probname = "hs29"
probname = "hs30"
probname = "hs31"
probname = "hs32"
probname = "hs33" #modificato il vincolo x[1] >= 0 in x[1]^3 >= 0
probname = "ex6"
probname = "hs08"
probname = "hs47"
probname = "hs52"

prob = find(collection,probname)

(n,m,p,f,g,h,x0) = use(prob)

#define gradient, lagrangian, penalty
include("prob_util.jl")

eps = 1.0
la = zeros(m)
mu = zeros(m)
xzero = 1.0*x0[1]
xo = xzero

function P(x)
	return f(x) + (sum(h(x).^2) + sum(max.(0,g(x)).^2))/eps	
end
function nabla_P(x)
	gp = nabla_f(x)
	if p > 0
		gp += 2*nabla_h(x)*h(x)/eps
	end
	if m > 0
		gp += 2*nabla_g(x)*(max.(0,g(x)))/eps
	end
	return gp
end
function gradP!(storage,x)
	gt = nabla_P(x)
	for i = 1:length(x)
		storage[i] = gt[i]
	end
end
function feasibility_measure(x)
	viol = 0.0
	if p > 0
		viol = max(viol,maximum(abs.(h(x))))
	end
	if m > 0
		viol = max(viol,maximum(max.(0,g(x))))
	end
	return viol
end
function violkkt(x,la,mu)
	viol = feasibility_measure(x)
	return max(viol,norm(nabla_L(x,la,mu),Inf))
end

xk  = xo
tol = 1.e-5

while true
	res = optimize(P,gradP!,xk,g_tol=eps)
	xk = res.minimizer
	la = 2*max.(0,g(xk))/eps
	mu = 2*h(xk)/eps

	viol = feasibility_measure(xk)
	kkt  = violkkt(xk,la,mu)

	@printf("%13.6e %13.6e %13.6e %13.6e %5s\n",eps,viol,kkt,P(xk),res.g_converged)
	
	if (viol <= tol && eps <= tol) || (eps <= 1.e-16)
		break
	else
		eps = 0.9*eps
	end
end

@printf("\nPrimal solution:\n")
for i = 1:n
	@printf("\t x[%3d] = %13.6e\n",i,xk[i])
end
@printf("  Dual solution:\n")
for i = 1:m
	@printf("\tla[%3d] = %13.6e\n",i,la[i])
end
for i = 1:p
	@printf("\tmu[%3d] = %13.6e\n",i,mu[i])
end

nothing
